'''SimpleEditor
'''v.02
'''TStatusBar bug fix
'''TToolBar small changes
'''TIniFile bug fix
'''Added
'''.....
'''ToolBar + most recent utility

#libpath "..\..\source\libs\"

#Include "..\..\Source\Forms.bi"
#Inclib "Forms"

#include "..\..\Source\utils.bi"
#include "..\..\Source\opendialog.bas"
#include "..\..\Source\savedialog.bas"
#include "..\..\Source\fontdialog.bas"
#include "..\..\Source\colordialog.bas"
#Include "..\..\Source\TMemo.bas"
#include "..\..\Source\TStatusBar.bas"
#Include "..\..\Source\TToolBar.bas"
#include "..\..\Source\TIniFile.bas"

using Colors

Dim shared as integer Saved=1
dim shared as string File

static shared as TMenuItem mFile,mNew,mOpen,mSave,mSaveAs,mExit
static shared as TMenuItem mEdit,mFont,mBackColor,mWordWrap
static shared as TMenuItem mAbout,mSoftware
    
dim shared as TForm Form
dim shared as TToolBar ToolBar
dim shared as TMemo Memo
dim shared as TStatusBar StatusBar
dim shared as TOpenDialog OpenDialog
dim shared as TSaveDialog SaveDialog
dim shared as TFontDialog FontDialog
dim shared as TColorDialog ColorDialog
dim shared as TIniFile IniFile

declare sub FormCreate(Sender as TForm)
declare sub FormClose(Sender as TForm,byref CloseAction as integer)

declare sub MemoChange(Sender as TMemo)

declare sub NewClick(Sender as TMenuItem)
declare sub OpenClick(Sender as TMenuItem)
declare sub SaveClick(Sender as TMenuItem)
declare sub SaveAsClick(Sender as TMenuItem)
declare sub ExitClick(Sender as TMenuItem)
declare sub FontClick(Sender as TMenuItem)
declare sub BackColorClick(Sender as TMenuItem)
declare sub WordwrapClick(Sender as TMenuItem)
declare sub SoftwareClick(Sender as TMenuItem)
declare sub ToolBarButtonClick(Sender as TToolBar,ButtonID as integer)

declare sub mostrecentClick(Sender as TMenuItem)

static shared as TStringList MostRecent
static shared as TPopupMenu MostRecentMenu
static shared as TMenuItem MostRecentItems()

Form.onCreate=@FormCreate
Form.onClose=@FormClose
Form.Parent=0
Form.Visible=1

    
sub FormCreate(Sender as TForm)
    static as TIcon Icon
    icon.LoadFromResourceName("main")
    Sender.Icon=Icon
    
    IniFile.File=Extractfilepath(command(0)) & "\SimpleEditor.ini"
    
    memo.Font.name=IniFile.ReadString("Font","Name","lucida console")
    memo.Font.Size=IniFile.ReadInteger("Font","Size",10)
    memo.Font.Color=IniFile.ReadInteger("Font","Color",clBlack)
    memo.color=IniFile.ReadInteger("Memo","Color",clWindow)
    memo.Scrollbars=IniFile.ReadInteger("Memo","ScroollBars",3)
    
    Sender.Width=IniFile.ReadInteger("Form","cx",750)
    Sender.Height=IniFile.ReadInteger("Form","cy",550)
    Sender.Left=IniFile.ReadInteger("Form","x",(GetSystemMetrics(sm_cxscreen)-750)/2)
    Sender.Top=IniFile.ReadInteger("Form","y",(GetSystemMetrics(sm_cyscreen)-550)/2)
    
    IniFile.ReadSectionValues("mostrecent",mostrecent)
    
    redim mostrecentitems(mostrecent.count)
    for i as integer=0 to mostrecent.count-1
        mostrecentitems(i).caption=mostrecent.items(i)
        mostrecentitems(i).command=10000+i
        mostrecentitems(i).onClick=@mostrecentClick
        mostrecentmenu.add(mostrecentitems(i))
    next i
    
    Sender.Caption="Simple Editor"
    '''Sender.Center=1
    
    OpenDialog.Owner=Sender
    SaveDialog.Owner=Sender
    FontDialog.Owner=Sender
    ColorDialog.Owner=Sender
    
    mNew.Command=10  
    mOpen.Command=11
    mSave.Command=12
    mSaveAs.Command=13
    mExit.Command=14
    mFont.Command=15
    mBackColor.Command=16
    mWordWrap.Command=17
    mSoftware.Command=18

    mFile.Caption="File"
    mNew.Caption="New"
    mOpen.Caption="Open"
    mSave.Caption="Save"
    mSaveAs.Caption="Save As..."
    mExit.Caption="Exit"
    mEdit.Caption="Edit"
    mFont.Caption="Font..."
    mBackColor.Caption="BackColor"
    mWordWrap.Caption="WordWrap"
    mAbout.Caption="About"
    mSoftware.Caption="Software"
    
    mFile.Add(mNew)
    mFile.Add(mOpen)
    mFile.Add(mSave)
    mFile.Add(mSaveAs)
    mFile.Add(mExit)
    mEdit.Add(mFont)
    mEdit.Add(mBackColor)
    mEdit.Add(mWordwrap)
    mAbout.Add(mSoftware)
    
    Sender.Menu.Add(mFile)
    Sender.Menu.Add(mEdit)
    Sender.Menu.Add(mAbout)
    
    mNew.onClick=@NewClick
    mOpen.onClick=@OpenClick
    mSave.onClick=@SaveClick
    mSaveAs.onClick=@SaveAsClick
    mExit.onClick=@ExitClick
    mFont.onClick=@FontClick
    mBackColor.onClick=@BackColorClick
    mWordwrap.onClick=@WordwrapClick
    mSoftware.onClick=@SoftwareClick
    
    static as TBitmap Bitmaps(4) '''build bitmap array
    Bitmaps(0)="new" '''load from resources or files, TBitmap search for both 
    Bitmaps(1)="open"
    Bitmaps(2)="save"
    Bitmaps(3)="exit"
    
    static as TImageList images '''build timagelist
    images.AddMasked(Bitmaps(0),&HFF00FF) '''add bitmap masked
    images.AddMasked(Bitmaps(1),&HFF00FF)
    images.AddMasked(Bitmaps(2),&HFF00FF)
    images.AddMasked(Bitmaps(3),&HFF00FF)

    ToolBar.Parent=Sender
    ToolBar.Align=3
    ToolBar.AddButton(tbstyle_sep)
    ToolBar.AddButton
    ToolBar.AddButton(tbstyle_dropdown,,,MostRecentMenu)
    ToolBar.AddButton
    ToolBar.AddButton(tbstyle_sep)
    ToolBar.AddButton
    ToolBar.onButtonClick=@ToolBarButtonClick
    ToolBar.Images=images '''assign imagelist
    
    StatusBar.Parent=Sender
    StatusBar.Add
    StatusBar.Add
    StatusBar.Panels(0)->Width=100
    StatusBar.Panels(0)->Alignment=1
    StatusBar.Align=4
    
    Memo.Parent=Sender
    Memo.Align=5
    Memo.onChange=@MemoChange
    
    NewClick(mNew)
end Sub

sub mostrecentClick(Sender as TMenuItem)
    dim as string s=trim(Sender.Caption,"&")
    dim as integer exists=0
    if open(s for binary access read as #1)=0 then '''check if file exists
        exists=1
        close(1)
    end if
    if exists then
        NewClick(mNew)
        Memo.LoadFromFile(s)
        Saved=1
    else
        MessageBox(Form.Handle,"File not exists.","Simple Editor",mb_iconerror)
    end if    
end sub

sub NewClick(Sender as TMenuItem)
    if Saved=0 then
        select case messagebox(Form.Handle,!"Your work was changed.\nDo you want to save ?","SimpleEditor",mb_yesnocancel or mb_iconquestion)
        case idyes
             SaveClick(mSave)
        case idno
            '''do nothing
        case idcancel
            exit sub 'abort
        end select
    end if
    Memo.Clear
    memo.setfocus
    StatusBar.panels(0)->text="Lin: " & Memo.caretpos.y & ", Col: " & memo.caretpos.x
end sub

sub OpenClick(Sender as TMenuItem)
    opendialog.filter="Text files (*.txt)|*.txt|All files(*,*)|*.*"
    if opendialog.execute then
        file=opendialog.filename
        memo.loadfromfile(file)
        if MostRecent.IndexOf(file)=-1 then
           MostRecent.Add(File)
           redim preserve mostrecentitems(ubound(mostrecentitems)+1) as tmenuitem
           mostrecentitems(ubound(mostrecentitems)-1).Caption=file
           mostrecentitems(ubound(mostrecentitems)-1).Command=10000+ubound(mostrecentitems)
           mostrecentitems(ubound(mostrecentitems)-1).onClick=@mostrecentClick
           mostrecentmenu.Add(mostrecentitems(ubound(mostrecentitems)-1))
        end if
    end if
    statusbar.panels(1)->text=file
    memo.setfocus
end sub

sub SaveClick(Sender as TMenuItem)
    if File<>"" then
        Memo.savetofile(file)
        Saved=1
    else
       SaveAsClick(mSaveAs)
    end if
end sub

sub SaveAsClick(Sender as TMenuItem)
    savedialog.filter="Text files (*.txt)|*.txt|All files(*,*)|*.*"
    if savedialog.execute then 
        select case savedialog.filterindex
        case 1
            file=changefileext(savedialog.filename,".txt")
        case 2
            file=changefileext(savedialog.filename,"")
        end select
    end if
    memo.Savetofile(file)
    memo.setfocus
    statusbar.panels(1)->text=file
    saved=1
end sub

sub ExitClick(Sender as TMenuItem)
    if Saved=0 then
        select case messagebox(Form.Handle,!"Your work was changed.\nDo you want to save ?","SimpleEditor",mb_yesnocancel or mb_iconquestion)
        case idyes
             SaveClick(mSave)
        case idno
            '''do nothing
        case idcancel
            exit sub 'abort
        end select
    end if
    Postquitmessage(0)
end sub

sub FontClick(Sender as TMenuItem)
    fontdialog.font=memo.font
    if fontdialog.execute then 
        memo.font=fontdialog.font
    end if
    memo.setfocus
end sub

sub BackColorClick(Sender as TMenuItem)
    colordialog.color=memo.color
    if colordialog.execute then
        memo.color=colordialog.color
    end if
    memo.setfocus
end sub

sub WordwrapClick(Sender as TMenuItem)
    sender.checked=iif(sender.checked,0,1)
    memo.wordwrap=sender.checked
end sub

sub SoftwareClick(Sender as TMenuItem)
    MessageBox(Form.Handle,!"Simple Editor 1.0\nNastase Eodor-2010\nuse guitk-s lib","Simple Editor",mb_ok or mb_iconquestion)
end sub

sub MemoChange(Sender as TMemo)
    saved=0
    StatusBar.panels(0)->text="Lin: " & Memo.caretpos.y & ", Col: " & memo.caretpos.x
end sub

sub ToolBarButtonClick(Sender as TToolBar,ButtonID as integer)
    select case Buttonid
    case 1
        NewClick(mNew)
    case 2
        OpenClick(mOpen)
    case 3
        SaveClick(mSave)
    case 5
        FormClose(Form,1)
    end select
end sub

sub FormClose(Sender as TForm,byref CloseAction as integer)
    IniFile.WriteString("Font","Name",memo.Font.name)
    IniFile.WriteInteger("Font","Size",memo.Font.Size)
    IniFile.WriteInteger("Font","Color",memo.Font.Color)
    IniFile.WriteInteger("Memo","Color",memo.color)
    IniFile.WriteInteger("Memo","ScrollBars",memo.scrollbars)
    IniFile.WriteInteger("Form","x",sender.Left)
    IniFile.WriteInteger("Form","y",sender.Top)
    IniFile.WriteInteger("Form","cx",sender.Width)
    IniFile.WriteInteger("Form","cy",sender.Height)
    for i as integer=0 to mostrecent.count-1
        iniFile.WriteString("MostRecent","Item"&i,mostrecent.items(i))
    next i
    ExitClick(mExit)
end Sub

'''Main Loop---or you can made an application object 
dim as Msg Ms
while GetMessage(@Ms,0,0,0) > 0
    TranslateMessage(@Ms)
    DispatchMessage(@Ms)
wend
